package com.zxhy.hfilemanagermaster.largefile

import android.annotation.SuppressLint
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.example.hfilemanagermaster.R
import com.example.hfilemanagermaster.databinding.ItemMediaSelectBinding
import com.zxhy.hfilemanagermaster.data.MediaDataC
import com.zxhy.hfilemanagermaster.glide.loadIntoImageView
import com.zxhy.hfilemanagermaster.knife.inflate
import java.io.File

class LagerFileSelectorAdapter(
    private val selectAction: ((flag: Boolean) -> Unit)? = null
) : RecyclerView.Adapter<LagerFileSelectorAdapter.MediaSelectViewHolder>() {
    private val mediaList = arrayListOf<MediaDataC>()

    class MediaSelectViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        val binding = ItemMediaSelectBinding.bind(view)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): MediaSelectViewHolder {
        val root = R.layout.item_media_select.inflate(parent)
        return MediaSelectViewHolder(root)
    }

    override fun getItemCount(): Int {
        return mediaList.size
    }

    override fun onBindViewHolder(holder: MediaSelectViewHolder, position: Int) {
        val context = holder.binding.root.context
        val data = mediaList[position]

        holder.binding.apply {
            if (data.path.contains(".jpg")
                or
                data.path.contains(".mp4")
                or
                data.path.contains(".png")
            ) {
                loadIntoImageView(context, File(data.path), iv)
            } else if (data.path.contains(".txt")) {
                iv.setImageResource(R.mipmap.io_002)
            } else if (data.path.contains(".xlsx") or data.path.contains(".xls")) {
                iv.setImageResource(R.mipmap.as_85230)
            } else if (data.path.contains(".pdf")) {
                iv.setImageResource(R.mipmap.io_0012)
            } else if (data.path.contains(".ppt") or data.path.contains(".pptx")) {
                iv.setImageResource(R.mipmap.io_002223)
            } else if (data.path.contains(".apk")) {
                iv.setImageResource(R.mipmap.fe_98856)
            } else if (data.path.contains(".zip")) {
                iv.setImageResource(R.mipmap.qwett_98959)
            } else if (data.path.contains("log") && File(data.path).isFile) {
                iv.setImageResource(R.mipmap.rqwr_875)
            } else if (File(data.path).isDirectory) {
                iv.setImageResource(R.mipmap.tt_695)
            } else {
                iv.setImageResource(R.drawable.icon_file_unknown)
            }

            tvName.text = data.name
            tvSize.text = data.size
            ivSelector.isSelected = data.select
            flSelector.setOnClickListener {
                data.select = !data.select
                notifyItemChanged(position, "单条刷新")
            }
        }
        if (data == mediaList.last()) {
            selectAction?.invoke(mediaList.all { it.select })
        }
    }

    override fun onBindViewHolder(
        holder: MediaSelectViewHolder,
        position: Int,
        payloads: MutableList<Any>
    ) {
        val context = holder.binding.root.context
        val data = mediaList[position]

        //判断是做局部刷新还是单条刷新
        if (payloads.isEmpty()) {//局部刷新
            holder.binding.apply {
                if (data.path.contains(".jpg")
                    or
                    data.path.contains(".mp4")
                    or
                    data.path.contains(".png")
                ) {
                    loadIntoImageView(context, File(data.path), iv)
                } else if (data.path.contains(".txt")) {
                    iv.setImageResource(R.mipmap.io_002)
                } else if (data.path.contains(".xlsx") or data.path.contains(".xls")) {
                    iv.setImageResource(R.mipmap.as_85230)
                } else if (data.path.contains(".pdf")) {
                    iv.setImageResource(R.mipmap.io_0012)
                } else if (data.path.contains(".ppt") or data.path.contains(".pptx")) {
                    iv.setImageResource(R.mipmap.io_002223)
                } else if (data.path.contains(".apk")) {
                    iv.setImageResource(R.mipmap.fe_98856)
                } else if (data.path.contains(".zip")) {
                    iv.setImageResource(R.mipmap.qwett_98959)
                } else if (data.path.contains("log") && File(data.path).isFile) {
                    iv.setImageResource(R.mipmap.rqwr_875)
                } else if (File(data.path).isDirectory) {
                    iv.setImageResource(R.mipmap.tt_695)
                } else {
                    iv.setImageResource(R.drawable.icon_file_unknown)
                }

                tvName.text = data.name
                tvSize.text = data.size
                ivSelector.isSelected = data.select
                flSelector.setOnClickListener {
                    data.select = !data.select
                    notifyItemChanged(position, "单条刷新")
                }
                if (data == mediaList.last()) {
                    selectAction?.invoke(mediaList.all { it.select })
                }
            }
        } else {// 单条刷新
            holder.binding.apply {
                ivSelector.isSelected = data.select
            }
            super.onBindViewHolder(holder, position, payloads)

            selectAction?.invoke(mediaList.all { it.select })
        }

    }

    @SuppressLint("NotifyDataSetChanged")
    fun setData(data: List<MediaDataC>) {
        mediaList.clear()
        mediaList.addAll(data)
        notifyDataSetChanged()
    }


    @SuppressLint("NotifyDataSetChanged")
    fun setToggleSelect(): Boolean {
        val flag = mediaList.all { it.select }
        mediaList.forEach { it.select = !flag }
        notifyDataSetChanged()
        return !flag
    }

    fun getSelectSize(): Int {
        return mediaList.count { it.select }
    }

    fun getSelectData(): List<MediaDataC> {
        return mediaList.filter { it.select }
    }

    @SuppressLint("NotifyDataSetChanged")
    fun addData(data: List<MediaDataC>) {
        val index = mediaList.size
        mediaList.addAll(data)
        notifyItemRangeChanged(index, data.size)
//        Log.e("FileSelectorAdapter", mediaList.size.toString())
    }

    @SuppressLint("NotifyDataSetChanged")
    fun removeData(file: List<MediaDataC>) {
        mediaList.removeAll(file.toSet())
//        file.forEachIndexed { index, mediaDataC ->
//            Log.e("removeData", "index=$index $mediaDataC")
//        }
        notifyDataSetChanged()
    }


}